<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/FileIndex.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/FileIndex.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/FileIndex.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html">FileIndex</a>(View):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A view that creates an index of files, and an index for each file.</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">    First the index of files is created, intended for the top-left frame.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">    Second a view is created for each file, listing the major declarations for</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">    that file, eg: classes, global functions, namespaces, etc.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#register">register</a>(self, frame):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">       super(FileIndex, self).register(frame)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">       self.__filename = <span class="py-string">''</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">       self.__title = <span class="py-string">''</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">       self.link_source = self.processor.has_view(<span class="py-string">'Source'</span>) <span class="py-keyword">and</span> self.processor.sxr_prefix</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">       self.link_details = self.processor.has_view(<span class="py-string">'FileDetails'</span>)</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#filename">filename</a>(self):</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        <span class="py-string">&quot;&quot;&quot;since FileTree generates a whole file hierarchy, this method returns the current filename,</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">        which may change over the lifetime of this object&quot;&quot;&quot;</span></span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-keyword">return</span> self.__filename</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#title">title</a>(self):</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        <span class="py-string">&quot;&quot;&quot;since FileTree generates a while file hierarchy, this method returns the current title,</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">        which may change over the lifetime of this object&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-keyword">return</span> self.__title</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#register_filenames">register_filenames</a>(self):</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Registers a view for each file indexed.&quot;&quot;&quot;</span></span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-keyword">for</span> filename, file <span class="py-keyword">in</span> self.processor.ir.files.items():</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">            <span class="py-keyword">if</span> file.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">                filename = self.directory_layout.file_index(filename)</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">                self.processor.register_filename(filename, self, file)</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#process">process</a>(self):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for each known file.&quot;&quot;&quot;</span></span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-keyword">for</span> filename, file <span class="py-keyword">in</span> self.processor.ir.files.items():</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">            <span class="py-keyword">if</span> file.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                self.process_file(filename, file)</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/FileIndex/FileIndex.html#process_file">process_file</a>(self, filename, file):</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for the given file. The view is just an index,</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-string">        containing a list of declarations.&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-comment"># set up filename and title for the current view</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        self.__filename = self.directory_layout.file_index(filename)</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-comment"># (get rid of ../'s in the filename)</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        name = filename.split(os.sep)</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-keyword">while</span> len(name) <span class="py-keyword">and</span> name[0] == <span class="py-string">'..'</span>: <span class="py-keyword">del</span> name[0]</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        self.__title = os.sep.join(name)</span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        self.start_file()</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.write(element(<span class="py-string">'b'</span>, os.sep.join(name))+<span class="py-string">'\n'</span>)</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        <span class="py-keyword">if</span> self.link_source:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            link = rel(self.filename(),</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                      self.directory_layout.file_source(filename))</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">            self.write(div(<span class="py-string">''</span>, href(link, <span class="py-string">'source code'</span>, target=<span class="py-string">'content'</span>)) + <span class="py-string">'\n'</span>)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-keyword">if</span> self.link_details:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">            link = rel(self.filename(),</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">                       self.directory_layout.file_details(filename))</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">            self.write(div(<span class="py-string">''</span>, href(link, <span class="py-string">'details'</span>, target=<span class="py-string">'content'</span>)) + <span class="py-string">'\n'</span>)</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        self.write(div(<span class="py-string">'heading'</span>, <span class="py-string">'Declarations'</span>) + <span class="py-string">'\n'</span>)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        <span class="py-comment"># Sort items (by name)</span></span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        items = [(d.name, d) <span class="py-keyword">for</span> d <span class="py-keyword">in</span> file.declarations]</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        items.sort()</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        <span class="py-keyword">if</span> file.annotations.get(<span class="py-string">'language'</span>) == <span class="py-string">'Python'</span>:</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            scope = QualifiedPythonName()</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">            scope = QualifiedCxxName()</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        last = scope</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-keyword">for</span> name, decl <span class="py-keyword">in</span> items:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">            entry = self.processor.toc[name]</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> entry: <span class="py-keyword">continue</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            <span class="py-comment"># Print link to declaration's view</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            link = rel(self.filename(), entry.link)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            label = isinstance(decl, ASG.Function) <span class="py-keyword">and</span> decl.real_name <span class="py-keyword">or</span> decl.name</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">            i = 0</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">            <span class="py-keyword">while</span> i &lt; len(label) - 1 <span class="py-keyword">and</span> i &lt; len(scope) <span class="py-keyword">and</span> label[i] == scope[i]:</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                i += 1</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">            self.write(<span class="py-string">'&lt;/div&gt;'</span> * (len(scope) - i))</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">            scope = scope[:i]</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">            <span class="py-keyword">while</span> i &lt; len(label) - 1:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                scope = scope + (label[i],)</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                <span class="py-keyword">if</span> len(last) &gt;= len(scope) <span class="py-keyword">and</span> last[:len(scope)] == scope: div_bit = <span class="py-string">''</span></span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                <span class="py-keyword">else</span>: div_bit = label[i]+<span class="py-string">'&lt;br/&gt;\n'</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                self.write(<span class="py-string">'%s&lt;div class=&quot;fileview-scope&quot;&gt;'</span>%div_bit)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                i += 1</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            <span class="py-comment"># Now print the actual item</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            label = replace_spaces(escape(str(scope.prune(label))))</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">            title = <span class="py-string">'(%s)'</span>%decl.type</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            self.write(div(<span class="py-string">'href'</span>,href(link, label, target=<span class="py-string">'content'</span>, title=title)))</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">            <span class="py-comment"># Store this name in case, f.ex, it's a class and the next item is</span></span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            <span class="py-comment"># in that class scope</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line">            last = name</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        self.write(<span class="py-string">'&lt;/div&gt;\n'</span> * len(scope))</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        self.end_file()</span>
<a id="line115"></a><span class="lineno">115</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
